/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef TATEGAKI_COLOR_H
#define TATEGAKI_COLOR_H

#include <glib.h>
#include "tategaki.h"

typedef struct _Color {
	guchar r, g, b, a;
} Color;

gboolean color_from_str (gchar *name, Color *color);
guint8 color_to_intensity_uchar (Color color);
double color_to_intensity (Color color);

#define DEG_TO_NORM(DEG) (fmod(fmod((DEG),360)+360,360))

void rgb_to_hsv (double r, double g, double b, double *out_h, double *out_s, double *out_v);
void hsv_to_rgb (double h, double s, double v, double *out_r, double *out_g, double *out_b);
void rgb_to_hsl (double r, double g, double b, double *out_h, double *out_s, double *out_l);
void hsl_to_rgb (double h, double s, double l, double *out_r, double *out_g, double *out_b);
double hue_to_rgb (double m1, double m2, double h);
void hsv_to_hsl (double h, double s, double v, double *out_h, double *out_s, double *out_l);
void hsl_to_hsv (double h, double s, double l, double *out_h, double *out_s, double *out_v);

#endif
