/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef TATEGAKI_FONT_LIST_H
#define TATEGAKI_FONT_LIST_H

#include <ft2build.h>
#include FT_FREETYPE_H
#include <glib.h>
#include "encoding.h"

typedef struct _FontInfo {
	char *name;//japanese or english font name (encoding is not utf-8 but system locale)
	char *path;//font name (enconding is not utf-8 but system locale)
	char *key;//sort key (FamilyName + " " + StyleName + "\0")
	char *name_old; //before version1.0, font name has "Regular" style name, but 1.1 has not it, this parameter is used for backword compatibility.
	char *name_en;
	char *name_ps;
	guint32 face_index;
} FontInfo;

extern GList* font_list_create (GList *itemlist);
extern int font_list_destroy (GList *list);
extern GList* font_list_find_name(GList *list, gchar *name);

#endif
