/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef TATEGAKI_FONT_VERT_CACHE_TABLE_H
#define TATEGAKI_FONT_VERT_CACHE_TABLE_H

#include "font_gsub_table.h"
#include "font_mort_table.h"

typedef struct _VertCacheTable {
	FT_Face face;
	GSUB_Table *gsub_table;
	mort_Table *mort_table;
	GHashTable *vert_table;
} VertCacheTable;

extern void				vert_cache_table_destroy (VertCacheTable *vcache);
extern VertCacheTable*	vert_cache_table_create (FT_Face face);
extern int				vert_cache_table_reset (VertCacheTable *vcache);
extern FT_UInt			vert_cache_table_get_glyph_id (VertCacheTable *vcache, FT_UInt gid);

#endif
