/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#include "tategaki.h"
#include "tategaki_msgbox.h"
static GtkResponseType return_val;

static void response_callback (GtkWidget *dialog, gint response_id, gpointer dummy)
{
	return_val = response_id;
	gtk_widget_destroy (dialog);
}


GtkResponseType msgbox (
		GtkMessageType message_type,
		GtkButtonsType button_type, 
		GtkWidget *parent,
		gchar *message)
{
	GtkWidget *dialog;

	return_val = GTK_RESPONSE_CANCEL;
	dialog = gtk_message_dialog_new (
			GTK_WINDOW(parent),
			GTK_DIALOG_MODAL,
			message_type,
			button_type,
			"%s",
			message);

	g_signal_connect (dialog, "response", 
			G_CALLBACK(response_callback), NULL);
	g_signal_connect (dialog, "destroy",
			G_CALLBACK(gtk_main_quit), NULL);

	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_keep_above (GTK_WINDOW (dialog), TRUE);

	gtk_widget_show(dialog);
	gtk_main();
	return return_val;
}

/* vim: set fdm=marker ts=4 sw=4:*/
