/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#include "tategaki.h"
#include "tategaki_splash.h"
#include "tategaki_image.h"

static GtkWidget *win = NULL;


// require gtk_init or gimp_ui_init before calling this function.
void show_splash () {
	if (!win) {
		GdkPixbuf *pix;
		GtkWidget *img;
		int width, height;

		win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
		gtk_window_set_decorated (GTK_WINDOW(win), FALSE);

		pix = gdk_pixbuf_new_from_inline (-1, img_splash, FALSE, NULL);
		width  = gdk_pixbuf_get_width(pix);
		height = gdk_pixbuf_get_height(pix);

		img = gtk_image_new_from_pixbuf (pix);
		gtk_container_add (GTK_CONTAINER (win), img);
		gtk_widget_set_usize (win, width, height);
	}

	gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
	gtk_widget_show_all (win);

	while (gtk_events_pending ()) {
		gtk_main_iteration ();
	}
	return;
}


void hide_splash () {
	gtk_widget_hide (win);
	return;
}

/* vim: set fdm=marker ts=4 sw=4:*/
