/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#include "typeset_obj.h"
#include "typeset_obj_glyphbox.h"
#include "typeset_obj_ruby.h"
#include "typeset_obj_yoko.h"
#include FT_TRUETYPE_TABLES_H

#define UCHARRANGE(c) ((c)<0xFF ? ( (c)>0x00 ? (c):0x00 ):0xFF)

void swap_double (double *a, double *b) {
	double tmp = *a;
	*a = *b;
	*b = tmp;
}

//񕨂AĂꍇ̖񕨂̋l(ړ)BJISX4051
//ԂĺA0͋lߖA0.5͓񕪋l߁A0.25͎llB
//g̕yёO̕Ƃ̋lߗʂ𒲐߂Bǧ̋lߗʂɂĂ͍lȂB
void get_yaku_tsume_jisx4051 (CharClass prev, CharClass now, CharClass next, double *offset, double *advance)
{/*{{{*/
	//a-1 nߊʗށCI芇ʗށC_ދyы_ނ̎́CpƂB
	//    Ȍ̃x^g݂Ƃ\́u񕨔pvłB
	switch (now) {
		case CHAR_CLASS_YAKU_KUTEN: *offset =  0.00; *advance = 0.50; break;
		case CHAR_CLASS_YAKU_START: *offset = -0.50; *advance = 1.00; break;
		case CHAR_CLASS_YAKU_END:   *offset =  0.00; *advance = 0.50; break;
		case CHAR_CLASS_YAKU_CENTER:*offset = -0.25; *advance = 0.75; break;
		default:                    *offset =  0.00; *advance = 1.00; break;
	}
	//b-1 nߊʗނ̑OyяI芇ʗނ̌́C񕪃ALƂB
	if (now  == CHAR_CLASS_YAKU_START) {*offset = 0.00; *advance = 1.00;}
	if (prev == CHAR_CLASS_YAKU_END)   {*offset = 0.50;}
	//b-2 _ނ̌́C񕪃ALƂB
	if (prev == CHAR_CLASS_YAKU_KUTEN) {*offset = 0.50;}
	//c-1 _ނ̑Oł́ClALƂB
	if (prev == CHAR_CLASS_YAKU_CENTER) {*offset = 0.25;}
	if (now  == CHAR_CLASS_YAKU_CENTER) {*offset = 0.00; *advance = 0.75;}
	//c-2 _ނ̎Ɏnߊʗނꍇ́C_ނƎnߊʗނƂ̊Ԃ͎lALƂB
	//    I芇ʗނ̎ɒ_ނꍇ́CI芇ʗނƒ_ނƂ̊Ԃ͎lALƂB
	if (prev == CHAR_CLASS_YAKU_CENTER && 
		now  == CHAR_CLASS_YAKU_START)  {*offset = -0.25;}
	if (prev == CHAR_CLASS_YAKU_END &&
		now  == CHAR_CLASS_YAKU_CENTER) {*offset = 0.00; *advance = 0.75;}
	//d-1 nߊʗނꍇ͏I芇ʗނꍇ́Cx^gƂB
	if (prev == CHAR_CLASS_YAKU_START &&
		now  == CHAR_CLASS_YAKU_START)  {*offset = -0.50; *advance = 1.00;}
	if (prev == CHAR_CLASS_YAKU_END &&
		now  == CHAR_CLASS_YAKU_END)    {*offset =  0.00; *advance = 0.50;}
	//d-2 I芇ʗނ̎ɎnߊʗނꍇCI芇ʗނƎnߊʗނƂ̊Ԃ́C񕪃ALƂB
	if (prev == CHAR_CLASS_YAKU_END &&
		now  == CHAR_CLASS_YAKU_START)  {*offset =  0.00; *advance = 1.00;}
	//e-1 _ނ̎ɏI芇ʗނꍇ́Cx^gƂB
	if (prev == CHAR_CLASS_YAKU_KUTEN &&
		now  == CHAR_CLASS_YAKU_END)  {*offset =  0.00; *advance = 0.50;}
	//e-2 I芇ʗނ̎ɋ_ނꍇ́Cx^gƂB
	if (prev == CHAR_CLASS_YAKU_END &&
		now  == CHAR_CLASS_YAKU_KUTEN)  {*offset =  0.00; *advance = 0.50;}
	//e-3 _ނ̎ɎnߊʗނꍇC_ނƎnߊʗނƂ̊Ԃ́C񕪃ALƂB
	if (prev == CHAR_CLASS_YAKU_KUTEN &&
		now  == CHAR_CLASS_YAKU_START)  {*offset =  0.00; *advance = 1.00;}
	//f-1 I芇ʗނs͊sɂꍇCI芇ʗނƍs͊sƂ̊Ԃ́Cx^gƂB
	if (now == CHAR_CLASS_YAKU_END &&
		next == CHAR_CLASS_NONE)         {*offset =  0.00; *advance = 0.50;}
	//f-2 _ނs͊sɂꍇ́C_ނ̑O͎lALƂC_ނ̌̓x^gƂB
	if (now == CHAR_CLASS_YAKU_CENTER &&
		next == CHAR_CLASS_NONE)         {*offset =  0.00; *advance = 0.75;}
	//g   i̎n܂Cs͊sɎnߊʗނꍇ́Cx^gƂB
	if (prev == CHAR_CLASS_NONE &&
		now == CHAR_CLASS_YAKU_START) {*offset = -0.50; *advance = 1.00;}

	return;
}/*}}}*/

CharClass get_char_class (gunichar n)
{/*{{{*/
	if (0x0030 <= n && n <= 0x0039) {
		return CHAR_CLASS_NUMBER;
	}
	if (n == 0x0021 || n == 0x003f ||
		n == 0x203c || n == 0x2047 ||
		n == 0x2048 || n == 0x2049) {
		return CHAR_CLASS_EXCLAM;
	}
	if (0x0020 <= n && n <= 0x024F) {
		return CHAR_CLASS_ALPHABET;
	}
	if (0xff61 <= n && n <= 0xff9f) {
		//pJi
		return CHAR_CLASS_ALPHABET;
	}
	switch (n) {
		case 0x3001://A
		case 0x3002://B
			return CHAR_CLASS_YAKU_KUTEN;
		case 0x2018://e
		case 0x201c://g
		case 0xff08://i
		case 0x3014://k
		case 0xff3b://m
		case 0xff5b://o
		case 0x3008://q
		case 0x300a://s
		case 0x300c://u
		case 0x300e://w
		case 0x3010://y
			return CHAR_CLASS_YAKU_START;
		case 0xff0c://C
		case 0xff0e://D
		case 0x2019://f
		case 0x201d://h
		case 0xff09://j
		case 0x3015://l
		case 0xff3d://n
		case 0xff5d://p
		case 0x3009://r
		case 0x300b://t
		case 0x300d://v
		case 0x300f://x
		case 0x3011://z
			return CHAR_CLASS_YAKU_END;
		case 0x30fb://E
		//case 0xff1a://F
		//case 0xff1b://G
			return CHAR_CLASS_YAKU_CENTER;
	}

	//NOTE:0x309b and 0x309c is *not* combining mark, but
	//     we should treat it as combining mark in tategaki.
	if (g_unichar_ismark(n) ||
		n == 0x3099 ||
		n == 0x309a ||
		n == 0x309b ||
		n == 0x309c) {
		return CHAR_CLASS_COMBINING;
	}

	if ((0x3041 <= n && n <= 0x309f) ||
		(0x30a0 <= n && n <= 0x30ff)) {
		return CHAR_CLASS_KANA;
	}

	return CHAR_CLASS_DEFAULT;
}/*}}}*/

//̌
GList* combine_glyph (GList *first)
{/*{{{*/
	GArray *in;
	GList *glist = first;

	in = g_array_new(TRUE, TRUE, sizeof(guint16));

	while (glist) {
		GlyphBox *gbox = glist->data;

		if (gbox->obj.type == TYPESET_OBJ_TYPE_RUBY) {
			Ruby *ruby = glist->data;
			ruby->parent = combine_glyph(ruby->parent);
			ruby->ruby = combine_glyph(ruby->ruby);
			glist = g_list_next(glist);
			continue;
		}

		if (gbox->obj.type != TYPESET_OBJ_TYPE_GLYPH) {
			glist = g_list_next(glist);
			continue;
		}

		//find base char and combining-chars sequence

		if (gbox->char_class != CHAR_CLASS_COMBINING) {
			GList *base, *next;

			base = glist;
			g_array_set_size(in, 0);
			g_array_append_val(in, gbox->glyph_id);
			if (g_list_next (glist) == NULL) break;

			next = g_list_next(base);
			while (next) {
				GlyphBox *next_gbox = next->data;
				if (next_gbox->char_class != CHAR_CLASS_COMBINING) {
					break;
				}
				g_array_append_val(in, next_gbox->glyph_id);
				next = g_list_next(next);
			}

			// search combining glyph id
			if (in->len > 1) {
				GlyphIdList gidin, gidout;
				FT_ULong tag_ccmp = FT_MAKE_TAG('c','c','m','p');

				gidin.size = in->len;
				gidin.gid = (void*)in->data;
				gsub_table_get_gid(gbox->obj.typesetter->face_table[gbox->obj.style].gsub_table, tag_ccmp, &gidin, &gidout);
				if (gidout.size == 0) {
					//replace U+3099 to U+309b, replace U+309a to U+309c.
					//because old truetype may not have glyphs for U+3099 and U+309a.
					GList *tmp = glist;
					while (tmp) {
						GlyphBox *tmp_gbox = tmp->data;
						if (tmp_gbox->unicode == 0x3099 || tmp_gbox->unicode == 0x309a) {
							switch (tmp_gbox->unicode) {
								case 0x3099: tmp_gbox->unicode = 0x309b; break;
								case 0x309a: tmp_gbox->unicode = 0x309c; break;
							}
							glyphbox_get_glyph_id(tmp_gbox);
						}
						tmp = g_list_next(tmp);
						if (g_list_previous(tmp) == next) break;
					} 
					if (next) glist = g_list_previous(next);
				} else {
					// Move combinign sequence chain to gbox->combining_sequence
					// and replace the sequence chain to one combined-glyph.
					GList *n_prev = g_list_previous(base);
					GList *n_next = next;
					GList *n = g_list_copy(base);
					GlyphBox *n_gbox;

					base->prev = NULL;
					if (next) next->prev->next = NULL;

					if (n_prev) n_prev->next = n;
					if (n_next) n_next->prev = n;
					n->prev = n_prev;
					n->next = n_next;

					n->data = glyphbox_create(((TypesetObj*)base->data)->parent);
					*(GlyphBox*)n->data = *(GlyphBox*)base->data;
					n_gbox = n->data;
					n_gbox->combining_sequence = base;
					n_gbox->glyph_id = gidout.gid[0];
					glist = n;
					first = g_list_first(glist);
				}
				if (gidout.gid) g_free(gidout.gid);
			}
		}
		if (glist) glist = g_list_next(glist);
	}
	
	g_array_free(in, TRUE);
	return first;
}/*}}}*/

void get_typo_metrics (FT_Face face, double *ascender, double *descender, double *linegap)
{/*{{{*/
	if (FT_IS_SFNT(face)) {
		TT_OS2 *os2 = (TT_OS2*)FT_Get_Sfnt_Table(face, ft_sfnt_os2);
		if (os2->version != 0xFFFF) {
			if (os2->sTypoAscender - os2->sTypoDescender == face->units_per_EM) {
				*ascender  = (double)face->size->metrics.y_ppem * os2->sTypoAscender  / face->units_per_EM;
				*descender = (double)face->size->metrics.y_ppem * os2->sTypoDescender / face->units_per_EM;
				*linegap   = (double)face->size->metrics.y_ppem * os2->sTypoLineGap   / face->units_per_EM;
				return;
			}
		}
	}
	*ascender  = F26D6_TO_DOUBLE(face->size->metrics.ascender);
	*descender = F26D6_TO_DOUBLE(face->size->metrics.descender);
	*linegap   = F26D6_TO_DOUBLE(face->size->metrics.height) - face->size->metrics.y_ppem;
}/*}}}*/

void get_scale (TypesetObj *obj, double *x, double *y)
{/*{{{*/
	double scale_x = 1;
	double scale_y = 1;
	TypesetObj *parent = obj->parent;
	while (parent) {
		switch (parent->type) {
			case TYPESET_OBJ_TYPE_RUBY: {
				Ruby *ruby = (Ruby*)parent;
				if (g_list_find(ruby->ruby, obj) != NULL) {
						scale_x *= 1;
						scale_y *= ruby->trans_rate;
				}
			}
			break;

			case TYPESET_OBJ_TYPE_YOKO: {
				Yoko *yoko = (Yoko*)parent;
				scale_y *= yoko->scale;
			}
			break;

			default:
			break;
		}
		scale_x *= parent->scale_x;
		scale_y *= parent->scale_y;
		parent = parent->parent;
	}
	*x = scale_x * obj->scale_x;
	*y = scale_y * obj->scale_y;

	if (obj->dir != DIR_TYPE_TTB) {
		swap_double(x, y);
	}
	return;
}/*}}}*/



//0,0w,ḧ̗SsrcdstɃRs[
void copy_glyph_image(Color color, gboolean rotate, gboolean antialias, guint8 *Dst, int dx, int dy, int dw, int dh, int planes, guint8 *Src, int sw, int sh, int sp)
{/*{{{*/
	int x, y;
	guint8 *dst, *src;

	if (planes == 4) {
		//]&A`GCAX
		if (rotate && antialias) {
			for (y = 0; y < sh; y++) {
				dst = Dst + (dx + (dy * dw) + (sh-y-1)) * planes;
				src = Src + (sp * y);
				for (x = 0; x < sw; x++) {
					dst[0] = color.r;
					dst[1] = color.g;
					dst[2] = color.b;
					dst[3] = UCHARRANGE(dst[3] + *src);
					dst+= dw * planes;
					src++;
				}
			}
		}
		//]Ȃ&A`GCAX
		if (!rotate && antialias) {
			for (y = 0; y < sh; y++) {
				dst = Dst + (dx + ((dy + y) * dw)) * planes;
				src = Src + (sp * y);
				for (x = 0; x < sw; x++) {
					dst[0] = color.r;
					dst[1] = color.g;
					dst[2] = color.b;
					dst[3] = UCHARRANGE(dst[3] + *src);
					dst+=planes;
					src++;
				}
			}
		}
		//]&A`GCAXȂ
		if (rotate && !antialias) {
			for (y = 0; y < sh; y++) {
				dst = Dst + (dx + (dy * dw) + (sh-y-1)) * planes;
				src = Src + (sp * y);
				for (x = 0; x < sw;) {
					if ( *src & (1  << (7 - (x % 8))) ) {
						dst[0] = color.r;
						dst[1] = color.g;
						dst[2] = color.b;
						dst[3] = color.a;
					}
					dst += dw * planes;
					x++;
					if (x % 8 == 0) src++;
				}
			}
		}
		//]Ȃ&A`GCAXȂ
		if (!rotate && !antialias) {
			for (y = 0; y < sh; y++) {
				dst = Dst + (dx + ((dy + y) * dw)) * planes;
				src = Src + (sp * y);
				for (x = 0; x < sw;) {
					if ( *src & (1  << (7 - (x % 8))) ) {
						dst[0] = color.r;
						dst[1] = color.g;
						dst[2] = color.b;
						dst[3] = color.a;
					}
					dst+=planes;
					x++;
					if (x % 8 == 0) src++;
				}
			}
		}
	}
	if (planes == 2) {
		//]&A`GCAX
		if (rotate && antialias) {
			for (y = 0; y < sh; y++) {
				dst = Dst + (dx + (dy * dw) + (sh-y-1)) * planes;
				src = Src + (sp * y);
				for (x = 0; x < sw; x++) {
					dst[0] = color.r;
					dst[1] = UCHARRANGE(dst[1] + *src);
					dst+= dw * planes;
					src++;
				}
			}
		}
		//]Ȃ&A`GCAX
		if (!rotate && antialias) {
			for (y = 0; y < sh; y++) {
				dst = Dst + (dx + ((dy + y) * dw)) * planes;
				src = Src + (sp * y);
				for (x = 0; x < sw; x++) {
					dst[0] = color.r;
					dst[1] = UCHARRANGE(dst[1] + *src);
					dst+=planes;
					src++;
				}
			}
		}
		//]&A`GCAXȂ
		if (rotate && !antialias) {
			for (y = 0; y < sh; y++) {
				dst = Dst + (dx + (dy * dw) + (sh-y-1)) * planes;
				src = Src + (sp * y);
				for (x = 0; x < sw;) {
					if ( *src & (1  << (7 - (x % 8))) ) {
						dst[0] = color.r;
						dst[1] = color.a;
					}
					dst+= dw * planes;
					x++;
					if (x % 8 == 0) src++;
				}
			}
		}
		//]Ȃ&A`GCAXȂ
		if (!rotate && !antialias) {
			for (y = 0; y < sh; y++) {
				dst = Dst + (dx + ((dy + y) * dw)) * planes;
				src = Src + (sp * y);
				for (x = 0; x < sw;) {
					if ( *src & (1  << (7 - (x % 8))) ) {
						dst[0] = color.r;
						dst[1] = color.a;
					}
					dst+=planes;
					x++;
					if (x % 8 == 0) src++;
				}
			}
		}
	}
	return;
}/*}}}*/


void obj_init(TypesetObj         *obj,
			  TypesetObj         *parent,
			  TypesetObjType      type,
			  Typesetter         *typesetter,
			  DirType             dir, 
			  FuncDestroy         func_destroy,
			  FuncResetStyle      func_reset_style,
			  FuncSetStyle        func_set_style,
			  FuncSetDir          func_set_dir,
			  FuncSetDot          func_set_dot,
			  FuncSetBold         func_set_bold,
			  FuncSetColor        func_set_color,
			  FuncGetGlyphID      func_get_glyph_id,
			  FuncCombineGlyph    func_combine_glyph,
			  FuncCacheGlyphImage func_cache_glyph_image,
			  FuncComputeGboxSize func_compute_gbox_size, 
			  FuncComputeSelfSize func_compute_self_size,
			  FuncGetSize         func_get_size,
			  FuncRender          func_render)
{/*{{{*/
	obj->parent = parent;
	obj->type = type;
	obj->typesetter = typesetter;
	obj->dir = dir;
	obj->dot = DOT_TYPE_NONE;
	obj->style = FONT_STYLE_BASE;
	obj->scale_x = 1;
	obj->scale_y = 1;
	obj->bold_x  = 0;
	obj->bold_y  = 0;
	obj->color.r = 0;
	obj->color.g = 0;
	obj->color.b = 0;
	obj->color.a = 1;
	obj->func_destroy = func_destroy;
	obj->func_reset_style = func_reset_style;
	obj->func_set_style = func_set_style;
	obj->func_set_dir = func_set_dir;
	obj->func_set_dot = func_set_dot;
	obj->func_set_bold = func_set_bold;
	obj->func_set_color = func_set_color;
	obj->func_get_glyph_id = func_get_glyph_id;
	obj->func_combine_glyph = func_combine_glyph;
	obj->func_cache_glyph_image = func_cache_glyph_image;
	obj->func_compute_gbox_size = func_compute_gbox_size;
	obj->func_compute_self_size = func_compute_self_size;
	obj->func_get_size = func_get_size;
	obj->func_render = func_render;
}/*}}}*/


/* vim: set fdm=marker ts=4 sw=4:*/
