/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef TATEGAKI_TYPESET_OBJ_GLYPHBOX_H
#define TATEGAKI_TYPESET_OBJ_GLYPHBOX_H
#include "typeset_obj.h"

typedef struct _GlyphBox {
	struct _TypesetObj	obj;
	CharClass		char_class;
	double		width;
	double		height;
	gunichar	code;
	guint32		unicode;
	guint32		variant_selector;
	FT_UInt		glyph_id;
	GList		*combining_sequence;
	gboolean	is_vert_glyph;    //cpOtC[W邩
	gboolean	rotate;//v90x]Ƃ1
	double		offset;
	double		advance;
} GlyphBox;

extern GlyphBox* glyphbox_create (TypesetObj* parent);
extern void glyphbox_destroy (GlyphBox *gbox);
extern void glyphbox_reset_style (GlyphBox *gbox);
extern void glyphbox_set_style (GlyphBox *gbox, int style);
extern void glyphbox_set_dir (GlyphBox *gbox, DirType dir);
extern void glyphbox_set_dot (GlyphBox *gbox, DotType dot);
extern void glyphbox_set_bold (GlyphBox *gbox, double bold_x, double bold_y);
extern void glyphbox_set_color (GlyphBox *gbox, Color color);
extern void glyphbox_get_glyph_id (GlyphBox *gbox);
extern void glyphbox_combine_glyph (GlyphBox *gbox);
extern void glyphbox_cache_glyph_image (GlyphBox *gbox);
extern void glyphbox_compute_gbox_size (GlyphBox *gbox, TypesetObj *prev, TypesetObj *next);
extern void glyphbox_compute_self_size (GlyphBox *gbox);
extern void glyphbox_get_size (GlyphBox *gbox, double *advance, double *offset, Rect *real_size, Rect *typo_size);
extern void glyphbox_render (GlyphBox *gbox, BufferContainer *buf);

/// (_̃_Oj*pɂ͌̂ЂƂÕx[XɂȂ镶w肷B
/// Ԃl̓x[X̎̕̕ԂB
extern GList* glyphbox_render_combining (GList *p, double base_advance, BufferContainer *buf);
#endif
