/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef TATEGAKI_TYPESET_OBJ_LAYOUT_H
#define TATEGAKI_TYPESET_OBJ_LAYOUT_H
#include "typesetter.h"
#include "typeset_obj.h"

typedef struct _Layout {
	struct _TypesetObj	obj;
	GList				*lines;
} Layout;

extern Layout *layout_create(Typesetter *typesetter, TypesetObj *parent);
extern void layout_destroy(Layout *layout);
extern void layout_reset_style(Layout *layout);
extern void layout_set_style(Layout *layout, int style);
extern void layout_set_dir(Layout *layout, DirType dir);
extern void layout_set_dot(Layout *layout, DotType dot);
extern void layout_set_bold(Layout *layout, double bold_x, double bold_y);
extern void layout_set_color(Layout *layout, Color color);
extern void layout_get_glyph_id(Layout *layout);
extern void layout_combine_glyph(Layout *layout);
extern void layout_cache_glyph_image(Layout *layout);
extern void layout_compute_gbox_size(Layout *layout, TypesetObj *prev, TypesetObj *next);
extern void layout_compute_self_size(Layout *layout);
extern void layout_get_size (Layout *layout, double *advance, double *offset, Rect *real_size, Rect *typo_size);
extern void layout_render (Layout *layout, BufferContainer *buf);

extern int layout_set_lines_from_sequence (Layout *layout, GList *in);
extern int layout_alloc_buffer (Layout *layout, BufferContainer *buf);
#endif