/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef TATEGAKI_TYPESET_OBJ_RUBY_H
#define TATEGAKI_TYPESET_OBJ_RUBY_H
#include "typesetter.h"
#include "typeset_obj.h"

typedef enum _RubyType {
	RUBY_TYPE_TOP,
	RUBY_TYPE_BOTTOM,
	RUBY_TYPE_CENTER,
	RUBY_TYPE_JUSTALL,
	RUBY_TYPE_JUST121
} RubyType;

typedef struct _Ruby {
	struct _TypesetObj obj;
	double	height;           //g݂ł͉Acg݂ł͏c
	double	parent_width;     //g݂ł͏cAcg݂ł͉
	double	parent_height;    //g݂ł͉Acg݂ł͏c
	int		parent_num;
	double	ruby_width;       //g݂ł͏cAcg݂ł͉
	double	ruby_height;      //g݂ł͉Acg݂ł͏c
	int		ruby_num;
	GList	*parent;
	GList	*ruby;
	RubyType ruby_type;//RubyType, AAAϓ
	gboolean does_trans;//re蒷ꍇ̂ɕό`B
	gboolean have_space;//does_transŕό`Ă͂ݏoꍇXy[X󂯂
	double  trans_rate;
	double  max_trans_rate;
} Ruby;

extern Ruby* ruby_create(Typesetter *typesetter, TypesetObj *parent, GList *seq_parent, GList *seq_ruby, int ruby_type, gboolean have_space, gboolean enable_trans, double max_trans_rate);
extern void ruby_destroy (Ruby *ruby);
extern void ruby_reset_style (Ruby *ruby);
extern void ruby_set_style (Ruby *ruby, int style);
extern void ruby_set_dir (Ruby *ruby, DirType  dir);
extern void ruby_set_dot (Ruby *ruby, DotType  dot);
extern void ruby_set_bold (Ruby *ruby, double bold_x, double bold_y);
extern void ruby_set_color (Ruby *ruby, Color color);
extern void ruby_get_glyph_id (Ruby *ruby);
extern void ruby_combine_glyph (Ruby *ruby);
extern void ruby_cache_glyph_image (Ruby *ruby);
extern void ruby_compute_gbox_size (Ruby *ruby, TypesetObj *prev, TypesetObj *next);
extern void ruby_compute_self_size(Ruby *ruby);
extern void ruby_get_size (Ruby *ruby, double *advance, double *offset, Rect *real_size, Rect *typo_size);
extern void ruby_render (Ruby *ruby, BufferContainer *buf);

void ruby_set_parent(Ruby *ruby, GList *seq);
void ruby_set_ruby(Ruby *ruby, GList *seq);
#endif