/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef TATEGAKI_TYPESET_OBJ_YOKO_H
#define TATEGAKI_TYPESET_OBJ_YOKO_H
#include "typesetter.h"
#include "typeset_obj.h"
#include "typeset_obj_glyphbox.h"

//cIuWFNg
typedef struct _Yoko {
	struct _TypesetObj	obj;
	GList		*elements;
	AlignType	align;
	double		scale;
} Yoko;


extern Yoko* yoko_create(Typesetter *typ, TypesetObj *parent, GList *elements, double trans, AlignType align);
extern void yoko_destroy(Yoko *yoko);
extern void yoko_reset_style(Yoko *yoko);
extern void yoko_set_style(Yoko *yoko, int style);
extern void yoko_set_dir(Yoko *yoko, DirType dir);
extern void yoko_set_dot(Yoko *yoko, DotType dot);
extern void yoko_set_bold(Yoko *yoko, double bold_x, double bold_y);
extern void yoko_set_color(Yoko *yoko, Color color);
extern void yoko_get_glyph_id (Yoko *yoko);
extern void yoko_combine_glyph (Yoko *yoko);
extern void yoko_cache_glyph_image (Yoko *yoko);
extern void yoko_compute_gbox_size (Yoko *yoko, TypesetObj *prev, TypesetObj *next);
extern void yoko_compute_self_size (Yoko *yoko);
extern void yoko_get_size (Yoko *yoko, double *advance, double *offset, Rect *real_size, Rect *typo_size);
extern void yoko_render (Yoko *yoko, BufferContainer *buf);
extern void yoko_debug_print (Yoko *yoko, gpointer data);
#endif