/*
 * GIMP Tategaki Plug-in -- This is a plug-in for The GIMP 2
 * Copyright (C) 2006-2017 OHTSUKA, Yoshio <ohtsuka.yoshio@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef TATEGAKI_TYPESET_PARSER_H
#define TATEGAKI_TYPESET_PARSER_H
#include <glib.h>
#include <string.h>
#include "typesetter.h"

typedef enum _TypesetCmdType {
	TYPESET_CMD_TYPE_NONE = 0,
	TYPESET_CMD_TYPE_RUBY_RT,	//r.cL
	TYPESET_CMD_TYPE_RUBY_RC,	//r.cL
	TYPESET_CMD_TYPE_RUBY_RB,	//r.cL
	TYPESET_CMD_TYPE_RUBY_RJA,	//r.ϓ
	TYPESET_CMD_TYPE_RUBY_RJJ,	//r.ϓ jisx4051[ɂ1:2:1z
	TYPESET_CMD_TYPE_RUBY_RTE,	//r.cL.rꍇ󔒂
	TYPESET_CMD_TYPE_RUBY_RCE,  //r.cL.rꍇ󔒂
	TYPESET_CMD_TYPE_RUBY_RBE,  //r.cL.rꍇ󔒂
	TYPESET_CMD_TYPE_RUBY_RJAE, //r.ϓ.rꍇ󔒂
	TYPESET_CMD_TYPE_RUBY_RJJE, //r.ϓ jisx4051[ɂ1:2:1z.rꍇ󔒂
	TYPESET_CMD_TYPE_YOKO,      //c
	TYPESET_CMD_TYPE_DOT,       //_()
	TYPESET_CMD_TYPE_GOMA,      //_(S})
	TYPESET_CMD_TYPE_SCALE,     //XP[igkj
	TYPESET_CMD_TYPE_BOLD,      //
	TYPESET_CMD_TYPE_FONT,      //tHg
	TYPESET_CMD_TYPE_COLOR      //F
} TypesetCmdType;

extern gpointer list_run_command (Typesetter *typesetter, gpointer parent, GList *command, int cmd_type);
extern gboolean list_is_match_str (GList *list, char *str);
extern void list_reset_style (Typesetter *typ, GList *seq);
extern GList* list_parse (Typesetter *typ, GList *seq);
extern GList* list_auto_yoko (Typesetter *typ, GList *seq);
extern void list_destroy_seq (GList *seq);

extern GList* get_gbox_sequence (Typesetter *typ, gchar *str, FontFlag flag);

#endif
