# make import library for VC++ from DLL.

append env(PATH) {;C:\Program Files\Microsoft Visual Studio 9.0\VC\bin;C:\Program Files\Microsoft Visual Studio 9.0\Common7\IDE;}
set dlls $argv

proc makedef {name text} {
    set def [split $text \n]
    set library [lindex [lindex $def 4] end]
    
    set llen [llength $def]
    set lcont 5
    while {$llen > $lcont} {
        set line [lindex $def $lcont]
        if {[lindex $line 0] eq "ordinal"} {
            break
        }
        incr lcont
    }
    
    set funcs [list]
    incr lcont 2
    while {$llen > $lcont} {
        set line [lindex $def $lcont]
        set func [lindex $line 3]
        if {$func eq ""} {break}
        lappend funcs $func
        incr lcont
    }
    
    set fp [open $name w]
    puts $fp "LIBRARY $library"
    puts $fp "EXPORTS"
    foreach func $funcs {
        puts $fp "\t$func"
    }
    close $fp
}

foreach token $dlls {
    if {[regexp {\*} $token] == 1} {
        set dlllist [glob -nocomp -- $token]
    } else {
        set dlllist $token
    }
    foreach dll $dlllist {
        set rootname [file rootname $dll]
        set deftext [exec dumpbin /exports $dll]
        makedef ${rootname}.def $deftext
        exec lib /def:${rootname}.def
        file delete ${rootname}.exp
    }
}

